<?php

/**
 * Enqueue scripts and styles.
 */
function zuzu_scripts() {



    wp_enqueue_style( 'google-fonts', '//fonts.googleapis.com/css2?family=Inter:wght@300;400;500;600;700;900&display=swap');

 
    wp_enqueue_style( 'font-awesomes', get_theme_file_uri( '/assets/css/all.min.css' ), array(), '5.15.1' );
	wp_enqueue_style('select2', get_theme_file_uri( '/assets/css/select2.min.css'), array(), null);
    wp_enqueue_style( 'bootstrap', get_theme_file_uri( '/assets/css/bootstrap.min.css' ), array(), '4.0' );
    wp_enqueue_style( 'nice-select', get_theme_file_uri( '/assets/css/nice-select.min.css' ), array(), 'null' );

    wp_enqueue_style( 'zuzu-core', get_theme_file_uri( '/assets/css/core.css' ), array(), ZUZU_THEME_VERSION );
    wp_style_add_data( 'zuzu-core', 'rtl', 'replace' );

    wp_enqueue_style( 'zuzu-custom', get_theme_file_uri( '/assets/css/theme-style.css' ), array(), ZUZU_THEME_VERSION );
    wp_style_add_data( 'zuzu-custom', 'rtl', 'replace' );

    wp_enqueue_style( 'zuzu-style', get_stylesheet_uri(), array(), ZUZU_THEME_VERSION );


    wp_enqueue_style( 'zuzu-responsive', get_theme_file_uri( '/assets/css/theme-responsive.css' ), array(), ZUZU_THEME_VERSION );
    wp_style_add_data( 'zuzu-responsive', 'rtl', 'replace' );

    wp_enqueue_script( 'jquery-masonry' );
	wp_enqueue_script('select2', get_theme_file_uri( '/assets/js/select2.min.js'), array('jquery'), null, true);
    wp_enqueue_script( 'nice-select', get_theme_file_uri( '/assets/js/jquery.nice-select.min.js' ), array( 'jquery' ), null, true );
    wp_enqueue_script( 'zuzu-main', get_theme_file_uri( '/assets/js/zuzu-main.js' ), array( 'jquery' ), ZUZU_THEME_VERSION, true );
    if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
        wp_enqueue_script( 'comment-reply' );
    }
}
add_action( 'wp_enqueue_scripts', 'zuzu_scripts' );



/**
 * Registers an editor stylesheet for the theme.
 */
function zuzu_theme_add_editor_styles() {
    add_editor_style( get_theme_file_uri( '/assets/css/editor-style.css' ) );
}
add_action( 'admin_init', 'zuzu_theme_add_editor_styles' );
