<?php

/**
 * The main template file
 *
 * This is the most generic template file in a WordPress theme
 * and one of the two required files for a theme (the other being style.css).
 * It is used to display a page when nothing more specific matches a query.
 * E.g., it puts together the home page when no home.php file exists.
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/
 *
 * @package zuzu
 */

use ZuzuTheme\Inc\Classes\Zuzu_Main;

get_header();

$zuzuObj = new Zuzu_Main();
echo esc_html($zuzuObj->zuzu_breadcrumb_bridge());

$zuzu = get_option('zuzu');
$grid = (isset($zuzu['blog_grid'])) ? $zuzu['blog_grid'] : 'two-column';

?>

<div class="content-block">
	<div class="container">
		<div class="row blog-content-row justify-content-center">

			<?php
			// If Redux Framework Active
			if (class_exists('ReduxFrameworkPlugin')) :
				$zuzuObj->postMarkupGenerator($zuzu['blog_layout'], $grid);
			else : // If Redux Framework Is Not Active
				$zuzuObj->postMarkupGenerator(null, $grid);
			endif;

			?>


		</div>
	</div>
</div>


<?php
get_footer();
