<?php

/**
 * The template for displaying search results pages
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/#search-result
 *
 * @package zuzu
 */

use ZuzuTheme\Inc\Classes\Zuzu_Main;

get_header();

$zuzuObj = new Zuzu_Main();
$zuzuObj->zuzu_breadcrumb_bridge();

$zuzu = get_option('zuzu');
$grid = (isset($zuzu['blog_grid'])) ? $zuzu['blog_grid'] : 'one-column';

?>

<div class="content-block sp-80">
	<div class="container">
		<div class="row blog-content-row justify-content-center">

			<?php
			// If Redux Framework Active
			if (have_posts()) :

				if (class_exists('ReduxFrameworkPlugin')) :
					$zuzuObj->postMarkupGenerator($zuzu['blog_layout'], $grid);

				else : // If Redux Framework Is Not Active

					$zuzuObj->postMarkupGenerator(null, $grid);

				endif;
			else :
				get_template_part('template-parts/contents/content-none');
			endif;
			?>
		</div>
	</div>
</div>


<?php
get_footer();
