<?php
/**
 * Happyden Team Widget.
 *
 *
 * @since 1.0.0
 */
use Elementor\Controls_Manager;
use Elementor\Group_Control_Border;
use Elementor\Group_Control_Box_Shadow;
use Elementor\Group_Control_Typography;
use Elementor\Widget_Base;
use Elementor\Group_Control_Background;
use Elementor\Group_Control_Css_Filter;
use Elementor\Icons_Manager;

if (!defined('ABSPATH')) {
    exit;
}
// If this file is called directly, abort.
class ZuzuTeam extends \Elementor\Widget_Base {
    public function get_name() {
        return 'zuzu_team';
    }
    public function get_title() {
        return __('Zuzu Team', 'zuzu-hp');
    }
    public function get_icon() {
        return ('eicon-person');
    }
    public function get_categories() {
        return ['zuzu-addons'];
    }
    public function get_keywords() {
        return ['team', 'membar', 'team'];
    }
    protected function register_controls() {
        $this->start_controls_section('general_section',
            [
                'label' => __('General ', 'zuzu-hp'),
                'tab'   => Controls_Manager::TAB_CONTENT,
            ]
        );

        $this->add_control(
            'membar_per_page',
            [
                'label'       => __('Numbar Of Membar', 'zuzu-hp'),
                'type'        => Controls_Manager::NUMBER,
                'default'     => '',
                'description' => 'user emty value show all posts',
            ]
        );

        $this->add_control(
            'team_style',
            [
                'label'             => __( 'Team Style', 'zuzu-hp' ),
                'type'              => Controls_Manager::SELECT,
                'default'           => 'team-area-style-01',
                'options'           => [
                    'team-area-style-01'   =>   __('Style One',    'zuzu-hp'),
                    'team-area-style-02'   =>   __('Style Two',    'zuzu-hp'),
                ],
                'separator' => 'after',
            ]
        );

        $this->add_control(
            'show_slider_settings',
            [
                'label' => __('Slider Active', 'zuzu-hp'),
                'type' => Controls_Manager::SWITCHER,
                'label_on' => __('Yes', 'zuzu-hp'),
                'label_off' => __('No', 'zuzu-hp'),
                'return_value' => 'yes',
                'default' => 'no',
            ]
        );

        $this->add_control(
            'show_socail_links',
            [
                'label' => __('Social  Links', 'zuzu-hp'),
                'type' => Controls_Manager::SWITCHER,
                'label_on' => __('Yes', 'zuzu-hp'),
                'label_off' => __('No', 'zuzu-hp'),
                'return_value' => 'yes',
                'default' => 'no',
                'condition'   => [
					'team_style' => 'team-area-style-02',
				]
            ]
        );

        $this->add_control(
            'show_readmore',
            [
                'label' => __('Show Readmore?', 'zuzu-ts'),
                'type' => \Elementor\Controls_Manager::SWITCHER,
                'label_on' => __('Yes', 'zuzu-ts'),
                'label_off' => __('No', 'zuzu-ts'),
                'return_value' => 'yes',
                'default' => 'yes',
            ]
        );


        $this->add_responsive_control(
            'gap_right',
            [
                'label'          => __('Gap Right', 'zuzu'),
                'type'           => Controls_Manager::SLIDER,
                'size_units'     => ['px', '%'],
                'range'          => [
                    'px' => [
                        'min' => 0,
                        'max' => 1000,
                    ],
                    '%' => [
                        'min' => 0,
                        'max' => 100,
                    ],
                ],
                'selectors'      => [
                    '{{WRAPPER}} .single-item' => 'margin-right: {{SIZE}}{{UNIT}};',
                    '{{WRAPPER}} .team-area ' => 'margin-right: -{{SIZE}}{{UNIT}};',
                ],
            ]
        );

        $this->add_responsive_control(
            'gap_bottom',
            [
                'label'          => __('Gap Bottom', 'zuzu'),
                'type'           => Controls_Manager::SLIDER,
                'size_units'     => ['px', '%'],
                'range'          => [
                    'px' => [
                        'min' => 0,
                        'max' => 1000,
                    ],
                    '%' => [
                        'min' => 0,
                        'max' => 100,
                    ],
                ],
                'selectors'      => [
                    '{{WRAPPER}} .single-item' => 'margin-bottom: {{SIZE}}{{UNIT}};',
                    '{{WRAPPER}} .team-area ' => 'margin-bottom: -{{SIZE}}{{UNIT}};',
                ],
            ]
        );
        $this->end_controls_section();


        $this->start_controls_section(
            'section_btn',
            [
                'label' => __( 'Readmore', 'zuzu-hp' ),
                'tab'   => \Elementor\Controls_Manager::TAB_CONTENT,
                'condition' => [
                    'show_readmore' => 'yes',
                 ]
            ]
        );

        $this->add_control(
            'readmore_text',
            [
                'label'    => __( 'Readmore text', 'zuzu-hp' ),
                'type'     => \Elementor\Controls_Manager::TEXT,
                'default'  => __( 'Read More', 'zuzu-hp' ),
                'conditon' => [
                    'show_readmore' => 'yes',
                ],
            ]
        );
        $this->add_control(
            'icon',
            [
                'label'    => __( 'Icon', 'zuzu-hp' ),
                'type'     => \Elementor\Controls_Manager::ICONS,
                'conditon' => [
                    'show_readmore' => 'yes',
                ],
            ]
        );
        $this->add_control(
            'icon_position',
            [
                'label'    => __( 'Icon Position', 'zuzu-hp' ),
                'type'     => \Elementor\Controls_Manager::SELECT,
                'default'  => 'after',
                'options'  => [
                    'before' => __( 'Before', 'zuzu-hp' ),
                    'after'  => __( 'After', 'zuzu-hp' ),
                ],
                'conditon' => [
                    'show_readmore' => 'yes',
                ],
            ]
        );
        $this->add_responsive_control(
            'button_align',
            [
                'label'        => __( 'Align', 'zuzu-hp' ),
                'type'         => \Elementor\Controls_Manager::CHOOSE,
                'options'      => [
                    'left'   => [
                        'title' => __( 'Left', 'zuzu-hp' ),
                        'icon'  => 'fa fa-align-left',
                    ],
                    'center' => [
                        'title' => __( 'top', 'zuzu-hp' ),
                        'icon'  => 'fa fa-align-center',
                    ],
                    'right'  => [
                        'title' => __( 'Right', 'zuzu-hp' ),
                        'icon'  => 'fa fa-align-right',
                    ],
                ],
                'devices'      => ['desktop', 'tablet', 'mobile'],
                'prefix_class' => 'content-align%s-',
                'toggle'       => true,
            ]
        );
        $this->end_controls_section();

        $this->start_controls_section('guery_section',
            [
                'label' => __('Query ', 'zuzu-hp'),
                'tab'   => Controls_Manager::TAB_CONTENT,
            ]
        );
        $this->add_responsive_control('per_line', [
            'label'              => __('Columns per row', 'zuzu-hp'),
            'type'               => Controls_Manager::SELECT,
            'default'            => '3',
            'tablet_default'     => '6',
            'mobile_default'     => '12',
            'options'            => [
                '12' => '1',
                '6'  => '2',
                '4'  => '3',
                '3'  => '4',
            ],
            'frontend_available' => true,
        ]);

        $this->add_control(
            'post_by',
            [
                'label' => __('Post By:', 'zuzu-hp'),
                'type' => Controls_Manager::SELECT,
                'default' => 'latest',
                'label_block' => true,
                'options' => array(
                    'latest'   =>   __('Latest Post', 'zuzu-hp'),
                    'selected' =>   __('Selected posts', 'zuzu-hp'),
                ),
            ]
        );
        $this->add_control(
            'post__in',
            [
                'label' => __('Post In', 'zuzu-hp'),
                'type' => Controls_Manager::SELECT2,
                'options' => zuzu_get_all_posts('team'),
                'multiple' => true,
                'label_block' => true,
                'condition'   => [
					'post_by' => 'selected',
				]
            ]
        );
       
        $this->add_control(
            'orderby',
            [
                'label' => __('Order By', 'zuzu-hp'),
                'type' => Controls_Manager::SELECT,
                'options' => zuzu_get_post_orderby_options(),
                'default' => 'date',
                'label_block' => true,

            ]
        );
        $this->add_control(
            'order',
            [
                'label' => __('Order', 'zuzu-hp'),
                'type' => Controls_Manager::SELECT,
                'options' => [
                    'asc' => 'Ascending',
                    'desc' => 'Descending',
                ],
                'default' => 'desc',
                'label_block' => true,

            ]
        );
        $this->end_controls_section();

        //Slider Setting
    $this->start_controls_section('slider_settings',
    [
            'label' => __('Slider Settings', 'zuzu-hp'),
            'tab'   => Controls_Manager::TAB_CONTENT,
            'condition' => [
                'show_slider_settings' => 'yes',
            ]
            ]
        );

        $this->add_responsive_control(
            'per_coulmn',
            [
                'label' => __( 'Slider Items', 'zuzu-hp' ),
                'type' => Controls_Manager::SELECT,
                'default'            => 3,
                'tablet_default'     => 2,
                'mobile_default'     => 1,
                'options'            => [
                    '1' => '1',
                    '2' => '2',
                    '3' => '3',
                    '4' => '4',
                    '5' => '5',
                ],
                'frontend_available' => true,
            ]
        );
        $this->add_control(
            'arrows',
            [
                'label' => __( 'Show arrows?', 'zuzu-hp' ),
                'type' => \Elementor\Controls_Manager::SWITCHER,
                'label_on' => __( 'Show', 'zuzu-hp' ),
                'label_off' => __( 'Hide', 'zuzu-hp' ),
                'return_value' => 'yes',
                'default' => 'yes',
            ]
        );

        $this->add_control(
            'dots',
            [
                'label' => __( 'Show Dots?', 'zuzu-hp' ),
                'type' => \Elementor\Controls_Manager::SWITCHER,
                'label_on' => __( 'Show', 'zuzu-hp' ),
                'label_off' => __( 'Hide', 'zuzu-hp' ),
                'return_value' => 'yes',
                'default' => 'yes',
            ]
        );

        $this->add_control(
            'mousedrag',
            [
                'label' => __( 'MouseDrag?', 'zuzu-hp' ),
                'type' => \Elementor\Controls_Manager::SWITCHER,
                'label_on' => __( 'Show', 'zuzu-hp' ),
                'label_off' => __( 'Hide', 'zuzu-hp' ),
                'return_value' => 'yes',
                'default' => 'yes',
            ]
        );

        $this->add_control(
            'autoplay',
            [
                'label' => __( 'Auto Play?', 'zuzu-hp' ),
                'type' => \Elementor\Controls_Manager::SWITCHER,
                'label_on' => __( 'Show', 'zuzu-hp' ),
                'label_off' => __( 'Hide', 'zuzu-hp' ),
                'return_value' => 'yes',
                'default' => 'yes',
            ]
        );
        // $this->add_control(
        //     'loop',
        //     [
        //         'label' => __( 'Infinite Loop', 'zuzu-hp' ),
        //         'type' => \Elementor\Controls_Manager::SWITCHER,
        //         'label_on' => __( 'Show', 'zuzu-hp' ),
        //         'label_off' => __( 'Hide', 'zuzu-hp' ),
        //         'return_value' => 'yes',
        //         'default' => 'true',
        //     ]
        // );
        $this->add_control(
            'autoplaytimeout',
            [
                'label' => __( 'Autoplay Timeout', 'zuzu-hp' ),
                'type' => \Elementor\Controls_Manager::SELECT,
                'label_block' => true,
                'default' => '5000',
                'options' => [
                    '1000'  => __( '1 Second', 'zuzu-hp' ),
                    '2000'  => __( '2 Second', 'zuzu-hp' ),
                    '3000'  => __( '3 Second', 'zuzu-hp' ),
                    '4000'  => __( '4 Second', 'zuzu-hp' ),
                    '5000'  => __( '5 Second', 'zuzu-hp' ),
                    '6000'  => __( '6 Second', 'zuzu-hp' ),
                    '7000'  => __( '7 Second', 'zuzu-hp' ),
                    '8000'  => __( '8 Second', 'zuzu-hp' ),
                    '9000'  => __( '9 Second', 'zuzu-hp' ),
                    '10000' => __( '10 Second', 'zuzu-hp' ),
                    '11000' => __( '11 Second', 'zuzu-hp' ),
                    '12000' => __( '12 Second', 'zuzu-hp' ),
                    '13000' => __( '13 Second', 'zuzu-hp' ),
                    '14000' => __( '14 Second', 'zuzu-hp' ),
                    '15000' => __( '15 Second', 'zuzu-hp' ),
                ],
                'condition' => [
                    'autoplay' => 'yes',
                ],
            ]
        );
        $this->add_control(
            'arrow_prev_icon',
            [
                'label' => __( 'Previous Icon', 'zuzu' ),
                'label_block' => false,
                'type' => \Elementor\Controls_Manager::ICONS,
                'skin' => 'inline',
                'default' => [
                    'value' => 'fas fa-chevron-left',
                    'library' => 'fa-solid',
                ],
                'condition' => [
                    'arrows' => 'yes'
                ],
            ]
        );

        $this->add_control(
            'arrow_next_icon',
            [
                'label' => __( 'Next Icon', 'zuzu' ),
                'label_block' => false,
                'type' => \Elementor\Controls_Manager::ICONS,
                'skin' => 'inline',
                'default' => [
                    'value' => 'fas fa-chevron-right',
                    'library' => 'fa-solid',
                ],
                'condition' => [
                    'arrows' => 'yes'
                ],
            ]
        );

        $this->add_responsive_control(
            'slider_width',
            [
                'label'          => __('Width', 'zuzu-hp'),
                'type'           => Controls_Manager::SLIDER,
                'size_units'     => ['%', 'px','vw'],
                'default'        => ['%'],
                'range'          => [
                    '%'  => [
                        'min' => 1,
                        'max' => 300,
                    ],
                    'px' => [
                        'min' => 1,
                        'max' => 1000,
                    ],
                    'vw' => [
                        'min' => 1,
                        'max' => 100,
                    ],
                ],
                'selectors'      => [
                    '{{WRAPPER}} .team-area-style-01 .slick-list' => 'width: {{SIZE}}{{UNIT}};',
                ],
            ]
        );



        $this->end_controls_section();

        /*
        *Image
        */
        $this->start_controls_section('team_box_iamge',
            [
                'label' => __('Image', 'zuzu-hp'),
                'tab'   => Controls_Manager::TAB_STYLE,
            ]
        );
        
        $this->start_controls_tabs('image_normal_tabs');
        // Normal tab
        $this->start_controls_tab(
            'iamge_normal_tab',
            [
                'label' => __('Normal', 'zuzu-hp'),
            ]
        );

        $this->add_group_control(
			Group_Control_Css_Filter::get_type(),
			[
				'name' => 'iamge_filter_normal',
				'selector' => '{{WRAPPER}} .team-wrapper img',
			]
		);

        $this->add_group_control(
            Group_Control_Border::get_type(),
            [
                'name'      => 'image_border',
                'selector'  => '{{WRAPPER}} .team-wrapper img',
                'separator' => 'before',
            ]
        );

        $this->add_group_control(
            Group_Control_Box_Shadow::get_type(),
            [
                'name'     => 'image_box_shadow',
                'exclude'  => [
                    'box_shadow_position',
                ],
                'selector' => '{{WRAPPER}} .team-wrapper img',
            ]
        );

        $this->add_responsive_control(
            'width',
            [
                'label'          => __('Width', 'zuzu-hp'),
                'type'           => Controls_Manager::SLIDER,
                'size_units'     => ['%', 'px','vw'],
                'range'          => [
                    '%'  => [
                        'min' => 1,
                        'max' => 100,
                    ],
                    'px' => [
                        'min' => 1,
                        'max' => 1000,
                    ],
                    'vw' => [
                        'min' => 1,
                        'max' => 100,
                    ],
                ],
                'selectors'      => [
                    '{{WRAPPER}} .team-wrapper img' => 'width: {{SIZE}}{{UNIT}};',
                ],
            ]
        );
        $this->add_responsive_control(
            'space',
            [
                'label'          => __('Max Width', 'zuzu-hp'),
                'type'           => Controls_Manager::SLIDER,
                'size_units'     => ['px', '%', 'vw'],
                'range'          => [
                    '%'  => [
                        'min' => 1,
                        'max' => 100,
                    ],
                    'px' => [
                        'min' => 1,
                        'max' => 1000,
                    ],
                    'vw' => [
                        'min' => 1,
                        'max' => 100,
                    ],
                ],
                'selectors'      => [
                    '{{WRAPPER}} .team-wrapper img' => 'max-width: {{SIZE}}{{UNIT}};',
                ],
            ]
        );
        $this->add_responsive_control(
            'height',
            [
                'label'          => __('Height', 'zuzu-hp'),
                'type'           => Controls_Manager::SLIDER,
                'size_units'     => ['px', 'vh'],
                'range'          => [
                    'px' => [
                        'min' => 1,
                        'max' => 1000,
                    ],
                    'vh' => [
                        'min' => 1,
                        'max' => 100,
                    ],
                ],
                'selectors'      => [
                    '{{WRAPPER}} .team-wrapper img' => 'height: {{SIZE}}{{UNIT}} !important;',
                ],
            ]
        );
        $this->add_responsive_control(
            'object-fit',
            [
                'label'     => __('Object Fit', 'zuzu-hp'),
                'type'      => Controls_Manager::SELECT,
                'condition' => [
                    'height[size]!' => '',
                ],
                'options'   => [
                    ''        => __('Default', 'zuzu-hp'),
                    'fill'    => __('Fill', 'zuzu-hp'),
                    'cover'   => __('Cover', 'zuzu-hp'),
                    'contain' => __('Contain', 'zuzu-hp'),
                ],
                'default'   => '',
                'selectors' => [
                    '{{WRAPPER}} .team-wrapper img' => 'object-fit: {{VALUE}};',
                ],
            ]
        );

        $this->add_responsive_control(
            'image_box_',
            [
                'label'      => __('Border Radius', 'zuzu-hp'),
                'type'       => Controls_Manager::DIMENSIONS,
                'size_units' => ['px', '%'],
                'selectors'  => [
                    '{{WRAPPER}} .team-wrapper img' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                    'body.rtl {{WRAPPER}} .team-wrapper img' => 'border-radius: {{TOP}}{{UNIT}} {{LEFT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{RIGHT}}{{UNIT}};',
                ],
            ]
        );
        $this->end_controls_tab();

        // Hover Style
        $this->start_controls_tab(
            'iamge_hover_tab',
            [
                'label' => __('Hover', 'zuzu-hp'),
            ]
        );
        $this->add_control(
            'image_hover_style',
            [
                'label'             => __('Image Hover Style', 'zuzu-hp'),
                'type'              => \Elementor\Controls_Manager::SELECT,
                'default'           => 'hover-default',
                'options'           => [
                    'hover-default' =>   __('Default',    'zuzu-hp'),
                    'hover-one'     =>   __('Style 01',    'zuzu-hp'),
                ],
                'separator' => 'after',
            ]
        );
        $this->add_group_control(
			Group_Control_Css_Filter::get_type(),
			[
				'name' => 'iamge_filter_hover',
				'selector' => '{{WRAPPER}} .team-wrapper:hover img',
			]
		);

        $this->end_controls_tab();
        $this->end_controls_tabs();
        $this->end_controls_section();

        /*
        *Name
        */
        $this->start_controls_section('team_box_name',
            [
                'label' => __('Name', 'zuzu-hp'),
                'tab'   => Controls_Manager::TAB_STYLE,
            ]
        );
        $this->add_control(
            'zuzu_team_name_color',
            [
                'label'     => __('Color', 'zuzu-hp'),
                'type'      => Controls_Manager::COLOR,
                'selectors' => [
                    '{{WRAPPER}}  .user-identity h6' => 'color: {{VALUE}}',
                ],
            ]
        );
        $this->add_group_control(
            Group_Control_Typography::get_type(),
            [
                'name'     => 'zuzu_team_name_style',
                'label'    => __('Typography', 'zuzu-hp'),
                'selector' => '{{WRAPPER}}   .user-identity h6',
            ]
        );
        $this->add_responsive_control(
            'zuzu_team_name_padding',
            [
                'label'      => __('Margin', 'zuzu-hp'),
                'type'       => Controls_Manager::DIMENSIONS,
                'size_units' => ['px'],
                'selectors'  => [
                    '{{WRAPPER}}  .user-identity h6' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                    'body.rtl {{WRAPPER}}  .user-identity h6' => 'margin: {{TOP}}{{UNIT}} {{LEFT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{RIGHT}}{{UNIT}};',
                ],
            ]
        );
        $this->end_controls_section();

        /*
        *Title
        */
        $this->start_controls_section('team_box_position',
            [
                'label' => __('Designation', 'zuzu-hp'),
                'tab'   => Controls_Manager::TAB_STYLE,
            ]
        );
        $this->add_control(
            'zuzu_team_position_color',
            [
                'label'     => __('Color', 'zuzu-hp'),
                'type'      => Controls_Manager::COLOR,
                'selectors' => [
                    '{{WRAPPER}} .user-identity span' => 'color: {{VALUE}}',
                ],
            ]
        );
        $this->add_group_control(
            Group_Control_Typography::get_type(),
            [
                'name'     => 'zuzu_team_position_style',
                'label'    => __('Typography', 'zuzu-hp'),
                'selector' => '{{WRAPPER}}  .user-identity span',
            ]
        );
        $this->add_responsive_control(
            'zuzu_team_position_padding',
            [
                'label'      => __('Margin', 'zuzu-hp'),
                'type'       => Controls_Manager::DIMENSIONS,
                'size_units' => ['px'],
                'selectors'  => [
                    '{{WRAPPER}} .user-identity span' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                    'body.rtl {{WRAPPER}} .user-identity span' => 'margin: {{TOP}}{{UNIT}} {{LEFT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{RIGHT}}{{UNIT}};',
                ],
            ]
        );
        $this->end_controls_section();

    /*
   *
    Dots
   */
    $this->start_controls_section(
        'dots_navigation',
        [
            'label' => __('Navigation - Dots', 'zuzu-hp'),
            'tab' => \Elementor\Controls_Manager::TAB_STYLE,
            'condition' => [
                'dots' => 'yes',
                'show_slider_settings' => 'yes'
            ],
        ]
    );
    $this->start_controls_tabs('_tabs_dots');

    $this->start_controls_tab(
        '_tab_dots_normal',
        [
            'label' => __('Normal', 'zuzu-hp'),
        ]
    );

    $this->add_control(
        'dots_color',
        [
            'label' => __('Color', 'zuzu-hp'),
            'type' => \Elementor\Controls_Manager::COLOR,
            'default' => '',
            'selectors' => [
                '{{WRAPPER}} .team-slider ul.team-slider-dot-list li' => 'background-color: {{VALUE}};',
            ],
        ]
    );

    // $this->add_responsive_control(
    //     'align',
    //     [
    //         'label' => __( 'Alignment', 'zuzu-hp' ),
    //         'type' => Controls_Manager::CHOOSE,
    //         'options' => [
    //             'flex-start' => [
    //                 'title' => __( 'Left', 'zuzu-hp' ),
    //                 'icon' => 'eicon-text-align-left',
    //             ],
    //             'center' => [
    //                 'title' => __( 'Center', 'zuzu-hp' ),
    //                 'icon' => 'eicon-text-align-center',
    //             ],
    //             'flex-end' => [
    //                 'title' => __( 'Right', 'zuzu-hp' ),
    //                 'icon' => 'eicon-text-align-right',
    //             ],
    //         ],
    //         'default' => 'center',
    //         'selectors' => [
    //             '{{WRAPPER}} .team-slider ul.team-slider-dot-list' => 'justify-content: {{VALUE}};',
    //         ],
    //     ]
    // );


    // $this->add_control(
    //     'dots_position_toggle',
    //     [
    //         'label' => __('Position', 'zuzu-hp'),
    //         'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
    //         'label_off' => __('None', 'zuzu-hp'),
    //         'label_on' => __('Custom', 'zuzu-hp'),
    //         'return_value' => 'yes',
    //     ]
    // );
    // $this->start_popover();


    // $this->add_responsive_control(
    //     'dots_position_y',
    //     [
    //         'label' => __('Vertical', 'zuzu-hp'),
    //         'type' => \Elementor\Controls_Manager::SLIDER,
    //         'size_units' => ['%','px'],
    //         'condition' => [
    //             'dots_position_toggle' => 'yes'
    //         ],
    //         'range' => [
    //             'px' => [
    //                 'min' => -1000,
    //                 'max' => 1000,
    //             ],
    //             '%' => [
    //                 'min' => -100,
    //                 'max' => 100,
    //             ],
    //         ],
    //         'selectors' => [
    //             '{{WRAPPER}} .team-slider ul.team-slider-dot-list' => 'top: {{SIZE}}{{UNIT}} !important;',
    //         ],
    //     ]
    // );

    // $this->add_responsive_control(
    //     'dots_position_x',
    //     [
    //         'label' => __('Horizontal', 'zuzu-hp'),
    //         'type' => \Elementor\Controls_Manager::SLIDER,
    //         'size_units' => ['px', '%'],
    //         'condition' => [
    //             'dots_position_toggle' => 'yes'
    //         ],
    //         'range' => [
    //             'px' => [
    //                 'min' => -1000,
    //                 'max' => 1000,
    //             ],
    //             '%' => [
    //                 'min' => 0,
    //                 'max' => 100,
    //             ],
    //         ],
    //         'selectors' => [
    //             'body:not(.rtl) {{WRAPPER}} .team-slider ul.team-slider-dot-list' => 'right: {{SIZE}}{{UNIT}};',
    //             'body.rtl {{WRAPPER}} .team-slider ul.team-slider-dot-list' => 'left: {{SIZE}}{{UNIT}};',
    //         ],
    //     ]
    // );
    // $this->end_popover();

    $this->add_responsive_control(
        'dots_box_width',
        [
            'label' => __('Width', 'zuzu-hp'),
            'type' => \Elementor\Controls_Manager::SLIDER,
            'size_units' => ['px'],
            'range' => [
                'px' => [
                    'min' => 0,
                    'max' => 200,
                ],
            ],
            'selectors' => [
                '{{WRAPPER}} .team-slider ul.team-slider-dot-list li' => 'width: {{SIZE}}{{UNIT}};',
            ],
        ]
    );

    $this->add_responsive_control(
        'dots_box_height',
        [
            'label' => __('Height', 'zuzu-hp'),
            'type' => \Elementor\Controls_Manager::SLIDER,
            'size_units' => ['px'],
            'range' => [
                'px' => [
                    'min' => 0,
                    'max' => 200,
                ],
            ],
            'selectors' => [
                '{{WRAPPER}} .team-slider ul.team-slider-dot-list li' => 'height: {{SIZE}}{{UNIT}};',
            ],
        ]
    );

    $this->add_responsive_control(
        'dots_margin',
        [
            'label'          => __('Gap Right', 'zuzu-hp'),
            'type'           => Controls_Manager::SLIDER,
            'default'        => [
                'unit' => 'px',
            ],
            'range'          => [
                'px' => [
                    'min' => 0,
                    'max' => 200,
                ],
            ],
            'selectors'      => [
                '{{WRAPPER}} .team-slider ul.team-slider-dot-list li ' => 'margin-right: {{SIZE}}{{UNIT}};',
                'body.rtl {{WRAPPER}} .team-slider ul.team-slider-dot-list li ' => 'margin-left: {{SIZE}}{{UNIT}};',
            ],
        ]
    );

    $this->add_responsive_control(
        'dots_min_margin',
        [
            'label'      => __('Margin', 'zuzu-hp'),
            'type'       => Controls_Manager::DIMENSIONS,
            'size_units' => ['px', '%'],
            'selectors'  => [
                '{{WRAPPER}} .team-slider-dot-list' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                'body.rtl {{WRAPPER}} .team-slider-dot-list' => 'margin: {{TOP}}{{UNIT}} {{LEFT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{RIGHT}}{{UNIT}};',
            ],
        ]
    );

    $this->add_responsive_control(
        'dots_box_',
        [
            'label'      => __('Border Radius', 'zuzu-hp'),
            'type'       => Controls_Manager::DIMENSIONS,
            'size_units' => ['px', '%'],
            'selectors'  => [
                '{{WRAPPER}} .team-slider ul.team-slider-dot-list li' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                'body.rtl {{WRAPPER}} .team-slider ul.team-slider-dot-list li' => 'border-radius: {{TOP}}{{UNIT}} {{LEFT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{RIGHT}}{{UNIT}};',
            ],
        ]
    );
    $this->end_controls_tab();

    $this->start_controls_tab(
        '_tab_dots_active',
        [
            'label' => __('Active', 'zuzu-hp'),
        ]
    );
    $this->add_control(
        'dots_color_active',
        [
            'label' => __('Active Color', 'zuzu-hp'),
            'type' => \Elementor\Controls_Manager::COLOR,
            'default' => '',
            'selectors' => [
                '{{WRAPPER}} .team-slider ul.team-slider-dot-list li.slick-active' => 'background-color: {{VALUE}}  !important;',
            ],
        ]
    );

    $this->add_responsive_control(
        'arrow_dots_box_active_width',
        [
            'label' => __('Width', 'zuzu-hp'),
            'type' => \Elementor\Controls_Manager::SLIDER,
            'size_units' => ['px'],
            'range' => [
                'px' => [
                    'min' => 0,
                    'max' => 200,
                ],
            ],
            'selectors' => [
                '{{WRAPPER}} .team-slider ul.team-slider-dot-list li.slick-active' => 'width: {{SIZE}}{{UNIT}} !important;',
            ],
        ]
    );

    $this->add_responsive_control(
        'arrow_dots_box_active_height',
        [
            'label' => __('Height', 'zuzu-hp'),
            'type' => \Elementor\Controls_Manager::SLIDER,
            'size_units' => ['px'],
            'range' => [
                'px' => [
                    'min' => 0,
                    'max' => 200,
                ],
            ],
            'selectors' => [
                '{{WRAPPER}} .team-slider ul.team-slider-dot-list li.slick-active' => 'height: {{SIZE}}{{UNIT}} !important;',
            ],
        ]
    );
    $this->end_controls_tab();
    $this->end_controls_tabs();

    $this->end_controls_section();

    /*
   *
    Arrows
   */
  $this->start_controls_section(
    'arrows_navigation',
    [
        'label' => __('Navigation - Arrow', 'zuzu-hp'),
        'tab' => \Elementor\Controls_Manager::TAB_STYLE,
        'condition' => [
            'arrows' => 'yes',
            'show_slider_settings' => 'yes'
        ],
    ]
);

$this->start_controls_tabs('_tabs_arrow');

$this->start_controls_tab(
    '_tab_arrow_normal',
    [
        'label' => __('Normal', 'zuzu-hp'),
    ]
);

$this->add_control(
    'arrow_color',
    [
        'label' => __('Color', 'zuzu-hp'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => '',
        'selectors' => [
            '{{WRAPPER}} .team-slider-arrow button' => 'color: {{VALUE}}; border-color: {{VALUE}};',
            '{{WRAPPER}} .team-slider-arrow button svg path' => 'stroke: {{VALUE}};',
        ],
    ]
);

$this->add_control(
    'arrow_color_fill',
    [
        'label' => __('Line Color', 'zuzu-hp'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => '',
        'selectors' => [
            '{{WRAPPER}} .team-slider-arrow button' => 'color: {{VALUE}};',
            '{{WRAPPER}} .team-slider-arrow button svg path' => 'fill: {{VALUE}};',
        ],
    ]
);

$this->add_control(
    'arrow_bg_color',
    [
        'label' => __('Background Color', 'zuzu-hp'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
             '{{WRAPPER}} .team-slider-arrow button' => 'background-color: {{VALUE}} !important;',
        ],
    ]
);

$this->add_group_control(
    \Elementor\Group_Control_Box_Shadow::get_type(),
    [
        'name' => 'arrow_shadow',
        'label' => __('Shadow', 'fd-addons'),
        'selector' => '{{WRAPPER}} .team-slider-arrow button ',
    ]
);

$this->add_control(
    'arrow_position_toggle',
    [
        'label' => __('Position', 'zuzu-hp'),
        'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
        'label_off' => __('None', 'zuzu-hp'),
        'label_on' => __('Custom', 'zuzu-hp'),
        'return_value' => 'yes',
    ]
);
$this->start_popover();

/*
Arrow Position
*/
$this->add_responsive_control(
    'arrow_position_y',
    [
        'label' => __('Vertical', 'zuzu-hp'),
        'type' => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['%','px'],
        'condition' => [
            'arrow_position_toggle' => 'yes'
        ],
        'range' => [
            'px' => [
                'min' => -1000,
                'max' => 1000,
            ],
            '%' => [
                'min' => -100,
                'max' => 100,
            ],
        ],
        'selectors' => [
            '{{WRAPPER}} .team-slider-arrow .prev, {{WRAPPER}} .team-slider-arrow .next' => 'top: {{SIZE}}{{UNIT}} !important;',
        ],
    ]
);

$this->add_responsive_control(
    'arrow_position_x',
    [
        'label' => __( 'Horizontal', 'happy-elementor-addons' ),
        'type' => Controls_Manager::SLIDER,
        'size_units' => ['px', '%'],
        'condition' => [
            'arrow_position_toggle' => 'yes'
        ],
        'range' => [
            'px' => [
                'min' => -200,
                'max' => 2000,
            ],
            '%' => [
                'min' => -200,
                'max' => 200,
            ],
        ],
        'selectors' => [
            '{{WRAPPER}}  .team-slider-arrow .prev' => 'left: {{SIZE}}{{UNIT}};',
            '{{WRAPPER}}  .team-slider-arrow .next' => 'right: {{SIZE}}{{UNIT}};',
        ],
    ]
);

$this->add_responsive_control(
    'arrow_position_dubol',
    [
        'label' => __( 'Horizontal Left Right', 'happy-elementor-addons' ),
        'type' => Controls_Manager::SLIDER,
        'size_units' => ['px', '%'],
        'condition' => [
            'arrow_position_toggle' => 'yes'
        ],
        'range' => [
            'px' => [
                'min' => -2000,
                'max' => 1000,
            ],
            '%' => [
                'min' => -200,
                'max' => 200,
            ],
        ],
        'selectors' => [
            '{{WRAPPER}} .team-slider-arrow .prev' => 'left: {{SIZE}}{{UNIT}} !important;',
        ],
    ]
);

$this->end_popover();

$this->add_responsive_control(
    'arrow_icon_size',
    [
        'label' => __('Icon Size', 'zuzu-hp'),
        'type' => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['px'],
        'range' => [
            'px' => [
                'min' => 10,
                'max' => 150,
            ],
        ],
        'selectors' => [
            '{{WRAPPER}}  .team-slider-arrow button i' => 'font-size: {{SIZE}}{{UNIT}}',
            '{{WRAPPER}}  .team-slider-arrow button svg' => 'width: {{SIZE}}{{UNIT}}',
        ],
    ]
);

$this->add_responsive_control(
    'arrow_size_box',
    [
        'label' => __('Size', 'zuzu-hp'),
        'type' => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['px'],
        'range' => [
            'px' => [
                'min' => 20,
                'max' => 150,
            ],
        ],
        'selectors' => [
            '{{WRAPPER}} .team-slider-arrow button' => 'height: {{SIZE}}{{UNIT}}; width: {{SIZE}}{{UNIT}}; line-height: {{SIZE}}{{UNIT}} !important;',
        ],
    ]

);
$this->add_responsive_control(
    'arrows_box_',
    [
        'label'      => __('Border Radius', 'zuzu-hp'),
        'type'       => Controls_Manager::DIMENSIONS,
        'size_units' => ['px'],
        'selectors'  => [
            '{{WRAPPER}} .team-slider-arrow button' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
            'body.rtl {{WRAPPER}} .team-slider-arrow button ' => 'border-radius: {{TOP}}{{UNIT}} {{LEFT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{RIGHT}}{{UNIT}};',
        ],
    ]
);
$this->end_controls_tab();

$this->start_controls_tab(
    '_tab_arrow_hover',
    [
        'label' => __('Active', 'zuzu-hp'),
    ]
);

$this->add_control(
    'arrow_hover_color',
    [
        'label' => __('Color', 'zuzu-hp'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
             '{{WRAPPER}} .team-slider-arrow .slick-active' => 'color: {{VALUE}};',
             '{{WRAPPER}} .team-slider-arrow button:hover ' => 'color: {{VALUE}};',
             '{{WRAPPER}} .team-slider-arrow .slick-active svg path' => 'stroke: {{VALUE}};',
             '{{WRAPPER}} .team-slider-arrow button:hover svg path ' => 'stroke: {{VALUE}};',
        ],
    ]
);

$this->add_control(
    'arrow_hover_fill_color',
    [
        'label' => __('Line Color', 'zuzu-hp'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
             '{{WRAPPER}} .team-slider-arrow .slick-active' => 'color: {{VALUE}};',
             '{{WRAPPER}} .team-slider-arrow button:hover ' => 'color: {{VALUE}};',
             '{{WRAPPER}} .team-slider-arrow .slick-active path' => 'fill: {{VALUE}};',
             '{{WRAPPER}} .team-slider-arrow button:hover path' => 'fill: {{VALUE}};',
        ],
    ]
);

$this->add_control(
    'arrow_bg_hover_color',
    [
        'label' => __('Background Color Hover', 'zuzu-hp'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
             '{{WRAPPER}} .team-slider-arrow button:hover ' => 'background-color: {{VALUE}}  !important;',
             '{{WRAPPER}} .team-slider-arrow .slick-active ' => 'background-color: {{VALUE}}  !important;',
        ],
    ]
);

$this->end_controls_tab();
$this->end_controls_tabs();

$this->end_controls_section();

        /*
        *Socail links
        */
        $this->start_controls_section('social_links',
        [
            'label' => __('Social Profile', 'zuzu-hp'),
            'tab'   => Controls_Manager::TAB_STYLE,
            'condition'   => [
                'show_socail_links' => 'yes',
            ]

        ]
        );

        $this->add_control(
            'icon_color',
            [
                'label'     => __('Color', 'zuzu-hp'),
                'type'      => Controls_Manager::COLOR,
                'selectors' => [
                    '{{WRAPPER}} .social-icons ul li i' => 'color: {{VALUE}}',
                ],
            ]
        );

        $this->add_control(
            'icon_color_hover',
            [
                'label'     => __('Color Hover', 'zuzu-hp'),
                'type'      => Controls_Manager::COLOR,
                'selectors' => [
                    '{{WRAPPER}} .social-icons ul li:hover i' => 'color: {{VALUE}}',
                ],
            ]
        );

        $this->add_responsive_control(
            'socail_align',
            [
                'label' => __( 'Alignment', 'zuzu-hp' ),
                'type' => Controls_Manager::CHOOSE,
                'options' => [
                    'flex-start' => [
                        'title' => __( 'Left', 'zuzu-hp' ),
                        'icon' => 'eicon-text-align-left',
                    ],
                    'center' => [
                        'title' => __( 'Center', 'zuzu-hp' ),
                        'icon' => 'eicon-text-align-center',
                    ],
                    'flex-end' => [
                        'title' => __( 'Right', 'zuzu-hp' ),
                        'icon' => 'eicon-text-align-right',
                    ],
                ],
                'default' => 'center',
                'selectors' => [
                    '{{WRAPPER}} .social-icons ul' => 'justify-content: {{VALUE}}',
                ],
            ]
        );

        $this->add_group_control(
			Group_Control_Background::get_type(),
			[
				'name'      => 'fd_addons_pricing_table_promo_background',
				'types'     => [ 'classic', 'gradient' ],
				'selector'  => '{{WRAPPER}} .social-icons:after',
			]
		);

        $this->add_responsive_control(
            'social_links_size',
            [
                'label'          => __('Size', 'zuzu-hp'),
                'type'           => Controls_Manager::SLIDER,
                'size_units'     => ['px'],
                'range'          => [
                    'px' => [
                        'min' => 1,
                        'max' => 100,
                    ],
                ],
                'selectors'      => [
                    '{{WRAPPER}} .social-icons ul li  i' => 'font-size: {{SIZE}}{{UNIT}};',
                    '{{WRAPPER}} .social-icons ul li svg' => 'width: {{SIZE}}{{UNIT}};',
                ],
            ]
        );

        $this->add_responsive_control(
            'social_links_box_',
            [
                'label'      => __('Border Radius', 'zuzu-hp'),
                'type'       => Controls_Manager::DIMENSIONS,
                'size_units' => ['px'],
                'selectors'  => [
                    '{{WRAPPER}} .social-icons' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                    'body.rtl {{WRAPPER}} .social-icons ' => 'border-radius: {{TOP}}{{UNIT}} {{LEFT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{RIGHT}}{{UNIT}};',
                ],
            ]
        );

        $this->add_responsive_control(
            'social_links_margin_icon',
            [
                'label'      => __('Right Gap', 'zuzu-hp'),
                'type'       => Controls_Manager::DIMENSIONS,
                'size_units' => ['px'],
                'selectors'  => [
                    '{{WRAPPER}} .social-icons ul li ' => 'margin-right: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                    'body.rtl {{WRAPPER}} .social-icons ul li  ' => 'margin-left: {{TOP}}{{UNIT}} {{LEFT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{RIGHT}}{{UNIT}};',
                ],
            ]
        );

        $this->add_responsive_control(
            'social_links_margin',
            [
                'label'      => __('Margin', 'zuzu-hp'),
                'type'       => Controls_Manager::DIMENSIONS,
                'size_units' => ['px'],
                'selectors'  => [
                    '{{WRAPPER}} .social-icons ul' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                    'body.rtl {{WRAPPER}} .social-icons ul' => 'margin: {{TOP}}{{UNIT}} {{LEFT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{RIGHT}}{{UNIT}};',
                ],
            ]
        );
        $this->end_controls_section();

        $this->start_controls_section(
            'button_style',
            [
                'label' => __( 'Read More Button', 'zuzu-hp' ),
                'tab'   => \Elementor\Controls_Manager::TAB_STYLE, 'condition' => [
                    'show_readmore' => 'yes',
                ],
            ]
        );
        $this->add_group_control(
            \Elementor\Group_Control_Typography::get_type(),
            [
                'name'     => 'btn_typography',
                'label'    => __( 'Button Typography', 'zuzu-hp' ),
                'selector' => '{{WRAPPER}} .team-btn',
            ]
        );
        $this->start_controls_tabs(
            'button_style_tabs'
        );
        $this->start_controls_tab(
            'button_style_normal_tab',
            [
                'label' => __( 'Normal', 'zuzu-hp' ),
            ]
        );
        $this->add_control(
            'btn_icon_color',
            [
                'label'     => __( 'Icon Color', 'zuzu-hp' ),
                'type'      => \Elementor\Controls_Manager::COLOR,
                'selectors' => [
                    '{{WRAPPER}} .team-btn .btn-icon'      => 'color: {{VALUE}}',
                    '{{WRAPPER}} .team-btn .btn-icon path' => 'stroke: {{VALUE}}',
                ],
            ]
        );
        $this->add_control(
            'icon_fill_color',
            [
                'label'     => __( 'Icon Fill Color', 'zuzu-hp' ),
                'type'      => \Elementor\Controls_Manager::COLOR,
                'selectors' => [
                    '{{WRAPPER}} .team-btn .btn-icon path' => 'fill: {{VALUE}}',
                ],
                'conditions' => [
					'relation' => 'or',
					'terms' => [
						[
							'name' => 'icon[library]',
							'operator' => '==',
							'value' => 'svg',
						],
					],
				],
            ]
        );
        $this->add_control(
            'boxed_btn_color',
            [
                'label'     => __( 'Button Color', 'zuzu-hp' ),
                'type'      => \Elementor\Controls_Manager::COLOR,
                'selectors' => [
                    '{{WRAPPER}} .team-btn' => 'color: {{VALUE}}',
                ],
            ]
        );
        $this->add_control(
            'boxed_btn_background',
            [
                'label'     => __( 'Background Color', 'zuzu-hp' ),
                'type'      => \Elementor\Controls_Manager::COLOR,
                'selectors' => [
                    '{{WRAPPER}} .team-btn' => 'background-color: {{VALUE}}',
                ],
            ]
        );
        $this->add_group_control(
            \Elementor\Group_Control_Box_Shadow::get_type(),
            [
                'name'     => 'button_shadow',
                'label'    => __( 'Button Shadow', 'zuzu-hp' ),
                'selector' => '{{WRAPPER}} .team-btn',
            ]
        );
        $this->add_group_control(
            \Elementor\Group_Control_Border::get_type(),
            [
                'name'     => 'button_border',
                'label'    => __( 'Border', 'zuzu-hp' ),
                'selector' => '{{WRAPPER}} .team-btn',
            ]
        );
        $this->add_control(
            'btn_icon_size',
            [
                'label'      => __( 'Icon Size', 'zuzu-hp' ),
                'type'       => \Elementor\Controls_Manager::SLIDER,
                'size_units' => ['px', 'em', '%'],
                'range'      => [
                    'px' => [
                        'min'  => 0,
                        'max'  => 50,
                        'step' => 1,
                    ],
                    '%'  => [
                        'min' => 0,
                        'max' => 100,
                    ],
                ],
                'selectors'  => [
                    '{{WRAPPER}} .team-btn .btn-icon'     => 'font-size: {{SIZE}}{{UNIT}};',
                    '{{WRAPPER}} .team-btn .btn-icon svg' => 'width: {{SIZE}}{{UNIT}};',
                ],
            ]
        );
        $this->add_control(
            'btn_icon_gap',
            [
                'label'      => __( 'Icon gap', 'zuzu-hp' ),
                'type'       => \Elementor\Controls_Manager::SLIDER,
                'size_units' => ['px', 'em', '%'],
                'range'      => [
                    'px' => [
                        'min' => 0,
                        'max' => 100,
                    ],
                    '%'  => [
                        'min' => 0,
                        'max' => 100,
                    ],
                ],
                'selectors'  => [
                    '{{WRAPPER}} .team-btn .icon-before, body.rtl {{WRAPPER}} .team-btn .icon-after '  => 'margin-right: {{SIZE}}{{UNIT}};',
                    '{{WRAPPER}} .team-btn .icon-after , body.rtl  {{WRAPPER}} .team-btn .icon-before' => 'margin-left: {{SIZE}}{{UNIT}};',
                ],
            ]
        );
        $this->add_responsive_control(
            'button_radius',
            [
                'label'      => __( 'Border Radius', 'zuzu-hp' ),
                'type'       => \Elementor\Controls_Manager::DIMENSIONS,
                'size_units' => ['px', 'em', '%'],
                'selectors'  => [
                    '{{WRAPPER}} .team-btn'          => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                    'body.rtl {{WRAPPER}} .team-btn' => 'border-radius: {{TOP}}{{UNIT}} {{LEFT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{RIGHT}}{{UNIT}};',
                ],
            ]
        );
        $this->add_control(
            'buton_style_divider',
            [
                'type' => \Elementor\Controls_Manager::DIVIDER,
            ]
        );
        $this->add_responsive_control(
            'button_padding',
            [
                'label'      => __( 'Button Padding', 'zuzu-hp' ),
                'type'       => \Elementor\Controls_Manager::DIMENSIONS,
                'size_units' => ['px', 'em', '%'],
                'selectors'  => [
                    '{{WRAPPER}} .team-btn'          => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                    'body.rtl {{WRAPPER}} .team-btn' => 'padding: {{TOP}}{{UNIT}} {{LEFT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{RIGHT}}{{UNIT}};',
                ],
            ]
        );
        $this->end_controls_tab();

        $this->start_controls_tab(
            'button_style_hover_tab',
            [
                'label' => __( 'Hover', 'zuzu-hp' ),
            ]
        );
        $this->add_control(
            'btn_icon_hover_color',
            [
                'label'     => __( 'Icon Color', 'zuzu-hp' ),
                'type'      => \Elementor\Controls_Manager::COLOR,
                'selectors' => [
                    '{{WRAPPER}} .zuzu-team-widget-item:hover .team-btn .btn-icon'      => 'color: {{VALUE}}',
                    '{{WRAPPER}} .zuzu-team-widget-item:hover .team-btn .btn-icon path' => 'stroke: {{VALUE}}',
                ],
            ]
        );
        $this->add_control(
            'btn_icon_fill_color_hover',
            [
                'label'     => __( 'Icon Fill Color', 'zuzu-hp' ),
                'type'      => \Elementor\Controls_Manager::COLOR,
                'selectors' => [
                    '{{WRAPPER}} .zuzu-team-widget-item:hover .team-btn .btn-icon path' => 'fill: {{VALUE}}',
                ],
                'conditions' => [
					'relation' => 'or',
					'terms' => [
						[
							'name' => 'icon[library]',
							'operator' => '==',
							'value' => 'svg',
						],
					],
				],
            ]
        );
        $this->add_control(
            'btn_hover_color',
            [
                'label'     => __( 'Button Color', 'zuzu-hp' ),
                'type'      => \Elementor\Controls_Manager::COLOR,
                'selectors' => [
                    '{{WRAPPER}} .zuzu-team-widget-item:hover .team-btn' => 'color: {{VALUE}}',
                ],
            ]
        );
        $this->add_control(
            'btn_hover_background',
            [
                'label'     => __( 'Background Color', 'zuzu-hp' ),
                'type'      => \Elementor\Controls_Manager::COLOR,
                'selectors' => [
                    '{{WRAPPER}} .team-btn:hover' => 'background-color: {{VALUE}}',
                ],
            ]
        );
        $this->add_group_control(
            \Elementor\Group_Control_Border::get_type(),
            [
                'name'     => 'button_hover_border',
                'label'    => __( 'Border', 'zuzu-hp' ),
                'selector' => '{{WRAPPER}} .team-btn:hover',
            ]
        );
        $this->add_control(
            'btn_hover_animation',
            [
                'label' => __( 'Hover Animation', 'zuzu-hp' ),
                'type'  => \Elementor\Controls_Manager::HOVER_ANIMATION,
            ]
        );
        $this->add_group_control(
            \Elementor\Group_Control_Box_Shadow::get_type(),
            [
                'name'     => 'button_hover_shadow',
                'label'    => __( 'Button Shadow', 'zuzu-hp' ),
                'selector' => '{{WRAPPER}} .team-btn:hover',
            ]
        );
        $this->add_responsive_control(
            'button_hover_radius',
            [
                'label'      => __( 'Border Radius', 'zuzu-hp' ),
                'type'       => \Elementor\Controls_Manager::DIMENSIONS,
                'size_units' => ['px', 'em', '%'],
                'selectors'  => [
                    '{{WRAPPER}} .team-btn:hover'          => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                    'body.rtl {{WRAPPER}} .team-btn:hover' => 'border-radius: {{TOP}}{{UNIT}} {{LEFT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{RIGHT}}{{UNIT}};',
                ],
            ]
        );
        $this->add_control(
            'icon_hover_gap',
            [
                'label'      => __( 'Icon gap', 'zuzu-hp' ),
                'type'       => \Elementor\Controls_Manager::SLIDER,
                'size_units' => ['px', 'em', '%'],
                'range'      => [
                    'px' => [
                        'min' => 0,
                        'max' => 100,
                    ],
                    '%'  => [
                        'min' => 0,
                        'max' => 100,
                    ],
                ],
                'selectors'  => [
                    '{{WRAPPER}} .team-btn:hover .icon-before'          => 'transform: translatex( -{{SIZE}}{{UNIT}} );',
                    '{{WRAPPER}} .team-btn:hover .icon-after '          => 'transform: translatex( {{SIZE}}{{UNIT}} );',
                ],
            ]
        );
        $this->end_controls_tab();
        $this->end_controls_tabs();
        $this->end_controls_section();

    /* Content box style */
    $this->start_controls_section('content_box',
        [
            'label' => __('Content Box', 'zuzu-hp'),
            'tab'   => Controls_Manager::TAB_STYLE,

        ]
    );

    $this->add_control(
        'content_bg',
        [
            'label'     => __('Backround Color', 'zuzu-hp'),
            'type'      => Controls_Manager::COLOR,
            'selectors' => [
                '{{WRAPPER}} .user-identity' => 'background-color: {{VALUE}}',
            ],
        ]
    );
    $this->add_group_control(
        Group_Control_Border::get_type(),
        [
            'name'      => 'content_box_border',
            'selector'  => '{{WRAPPER}} .user-identity',
        ]
    );

    
    $this->add_group_control(
        Group_Control_Box_Shadow::get_type(),
        [
            'name'     => 'content_box_shadow',
            'exclude'  => [
                'box_shadow_position',
            ],
            'selector' => '{{WRAPPER}} .user-identity',
        ]
    );
    $this->add_responsive_control(
       'content_align',
       [
           'label' => __( 'Alignment', 'zuzu-hp' ),
           'type' => Controls_Manager::CHOOSE,
           'options' => [
               'left' => [
                   'title' => __( 'Left', 'zuzu-hp' ),
                   'icon' => 'eicon-text-align-left',
               ],
               'center' => [
                   'title' => __( 'Center', 'zuzu-hp' ),
                   'icon' => 'eicon-text-align-center',
               ],
               'right' => [
                   'title' => __( 'Right', 'zuzu-hp' ),
                   'icon' => 'eicon-text-align-right',
               ],
           ],
           'default' => 'left',
           'selectors' => [
               '{{WRAPPER}} .user-identity' => 'text-align: {{VALUE}} !important;',
           ],
       ]
   );

     $this->add_responsive_control(
         'content_box_border_radius',
         [
             'label'      => __('Border Radius', 'zuzu-hp'),
             'type'       => Controls_Manager::DIMENSIONS,
             'size_units' => ['px', '%'],
             'selectors'  => [
                 '{{WRAPPER}} .user-identity' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                 'body.rtl {{WRAPPER}} .user-identity' => 'border-radius: {{TOP}}{{UNIT}} {{LEFT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{RIGHT}}{{UNIT}};',
             ],
         ]
     );


    $this->add_responsive_control(
    'content_box_margin',
        [
            'label'      => __('Margin', 'zuzu-hp'),
            'type'       => Controls_Manager::DIMENSIONS,
            'size_units' => ['px', '%'],
            'selectors'  => [
                '{{WRAPPER}} .user-identity' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                'body.rtl {{WRAPPER}} .user-identity' => 'margin: {{TOP}}{{UNIT}} {{LEFT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{RIGHT}}{{UNIT}};',
            ],
        ]
    );
    $this->add_responsive_control(
        'content_box_padding',
            [
                'label'      => __('Padding', 'zuzu-hp'),
                'type'       => Controls_Manager::DIMENSIONS,
                'size_units' => ['px', '%'],
                'selectors'  => [
                    '{{WRAPPER}} .user-identity' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                    'body.rtl {{WRAPPER}} .user-identity' => 'padding: {{TOP}}{{UNIT}} {{LEFT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{RIGHT}}{{UNIT}};',
                ],
            ]
    );
    $this->end_controls_section();

    /* box style */
    $this->start_controls_section('box',
        [
            'label' => __('Box', 'zuzu-hp'),
            'tab'   => Controls_Manager::TAB_STYLE,

        ]
    );

     $this->start_controls_tabs(
         'style_tabs'
     );
     // normal
     $this->start_controls_tab(
         'team_normal',
         [
             'label' => __('Normal', 'zuzu-hp'),
         ]
     );

     $this->add_control(
         'bg',
         [
             'label'     => __('Backround Color', 'zuzu-hp'),
             'type'      => Controls_Manager::COLOR,
             'selectors' => [
                 '{{WRAPPER}} .single-item' => 'background-color: {{VALUE}}',
             ],
         ]
     );
     $this->add_group_control(
         Group_Control_Border::get_type(),
         [
             'name'      => 'box_border',
             'selector'  => '{{WRAPPER}} .single-item',
         ]
     );

     $this->add_group_control(
         Group_Control_Box_Shadow::get_type(),
         [
             'name'     => 'box_shadow',
             'exclude'  => [
                 'box_shadow_position',
             ],
             'selector' => '{{WRAPPER}} .single-item',
         ]
     );
     $this->add_responsive_control(
        'align',
        [
            'label' => __( 'Alignment', 'zuzu-hp' ),
            'type' => Controls_Manager::CHOOSE,
            'options' => [
                'left' => [
                    'title' => __( 'Left', 'zuzu-hp' ),
                    'icon' => 'eicon-text-align-left',
                ],
                'center' => [
                    'title' => __( 'Center', 'zuzu-hp' ),
                    'icon' => 'eicon-text-align-center',
                ],
                'right' => [
                    'title' => __( 'Right', 'zuzu-hp' ),
                    'icon' => 'eicon-text-align-right',
                ],
            ],
            'default' => 'left',
            'selectors' => [
                '{{WRAPPER}} .single-item' => 'text-align: {{VALUE}} !important;',
            ],
        ]
    );

    $this->add_responsive_control(
        'margin_bottom',
        [
            'label'          => __('Bottom Gap', 'zuzu-hp'),
            'type'           => Controls_Manager::SLIDER,
            'default'        => [
                'unit' => 'px',
            ],
            'range'          => [
                'px' => [
                    'min' => 1,
                    'max' => 100,
                ],
            ],
            'selectors'      => [
                '{{WRAPPER}} .single-item' => 'margin-bottom: {{SIZE}}{{UNIT}};',
            ],
        ]
    );


    $this->add_responsive_control(
         'box_margin',
         [
             'label'      => __('Margin', 'zuzu-hp'),
             'type'       => Controls_Manager::DIMENSIONS,
             'size_units' => ['px'],
             'selectors'  => [
                 '{{WRAPPER}} .single-item' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                 'body.rtl {{WRAPPER}} .single-item' => 'margin: {{TOP}}{{UNIT}} {{LEFT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{RIGHT}}{{UNIT}};',
             ],
         ]
     );

    $this->add_responsive_control(
         'box_padding',
         [
             'label'      => __('Padding', 'zuzu-hp'),
             'type'       => Controls_Manager::DIMENSIONS,
             'size_units' => ['px'],
             'selectors'  => [
                 '{{WRAPPER}} .single-item' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                 'body.rtl {{WRAPPER}} .single-item' => 'padding: {{TOP}}{{UNIT}} {{LEFT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{RIGHT}}{{UNIT}};',
             ],
         ]
     );

     $this->add_responsive_control(
         'box_border_radius',
         [
             'label'      => __('Border Radius', 'zuzu-hp'),
             'type'       => Controls_Manager::DIMENSIONS,
             'size_units' => ['px', '%'],
             'selectors'  => [
                 '{{WRAPPER}} .single-item' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                 'body.rtl {{WRAPPER}} .single-item' => 'border-radius: {{TOP}}{{UNIT}} {{LEFT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{RIGHT}}{{UNIT}};',
             ],
         ]
     );

     $this->end_controls_tab();

     // hover
     $this->start_controls_tab(
         'box_hover',
         [
             'label' => __('Hover', 'zuzu-hp'),
         ]
     );

     $this->add_control(
         'bg_hover',
         [
             'label'     => __('Backround Color', 'zuzu-hp'),
             'type'      => Controls_Manager::COLOR,
             'selectors' => [
                 '{{WRAPPER}} .single-item:hover' => 'background-color: {{VALUE}}',
             ],
         ]
     );
     $this->add_group_control(
         Group_Control_Border::get_type(),
         [
             'name'      => 'tn_border_hover',
             'selector'  => '{{WRAPPER}} .single-item:hover',
         ]
     );

     $this->add_group_control(
         Group_Control_Box_Shadow::get_type(),
         [
             'name'     => 'box_shadow_hover',
             'exclude'  => [
                 'box_shadow_position',
             ],
             'selector' => '{{WRAPPER}} .single-item:hover',
         ]
     );

     $this->add_responsive_control(
         'box__hover',
         [
             'label'      => __('Border Radius', 'zuzu-hp'),
             'type'       => Controls_Manager::DIMENSIONS,
             'size_units' => ['px', '%'],
             'selectors'  => [
                 '{{WRAPPER}} .single-item:hover' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                 'body.rtl {{WRAPPER}} .single-item:hover' => 'border-radius: {{TOP}}{{UNIT}} {{LEFT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{RIGHT}}{{UNIT}};',
             ],
         ]
     );
     $this->end_controls_tab();
     $this->end_controls_tabs();
    $this->end_controls_section();

    }

    // protected function get_render_icon($icon){
    //     ob_start();
    //     \Elementor\Icons_Manager::render_icon($icon, ['aria-hidden' => 'true']);
    //     return ob_get_clean();
    // }

    protected function render() {
        $settings = $this->get_settings_for_display();
        $team_style  = $settings['team_style'];
        $image_hover_style = $settings['image_hover_style'];
         //this code course slider option
		$slider_extraSetting = array(

            // 'next_icon' => $this->get_render_icon($settings['arrow_next_icon']),
            // 'prev_icon' => $this->get_render_icon($settings['arrow_prev_icon']),
	        // 'loop' => (!empty($settings['loop']) && 'yes' === $settings['loop']) ? true : false,
	        'autoplay' => (!empty($settings['autoplay']) && 'yes' === $settings['autoplay']) ? true : false,
        	'nav' => (!empty($settings['arrows']) && 'yes' === $settings['arrows']) ? true : false,
        	'dots' => (!empty($settings['dots']) && 'yes' === $settings['dots']) ? true : false,
        	'mousedrag' => (!empty($settings['mousedrag']) && 'yes' === $settings['mousedrag']) ? true : false,
        	'autoplaytimeout' => !empty($settings['autoplaytimeout']) ? $settings['autoplaytimeout'] : '5000',

        	//this a responsive layout
            'per_coulmn' =>        (!empty($settings['per_coulmn'])) ? $settings['per_coulmn'] : 3,
            'per_coulmn_tablet' => (!empty($settings['per_coulmn_tablet'])) ? $settings['per_coulmn_tablet'] : 2,
            'per_coulmn_mobile' => (!empty($settings['per_coulmn_mobile'])) ? $settings['per_coulmn_mobile'] : 1
        );
        $jasondecode = wp_json_encode($slider_extraSetting);




        if ( ( 'yes' == $settings['show_slider_settings'] ) ) {
            $this->add_render_attribute('team_version', 'class', array('team-slider', 't-style',$image_hover_style ));
            $this->add_render_attribute('team_version', 'data-settings', $jasondecode);
        } else {
            $this->add_render_attribute('team_version', 'class', array('row g-0 justify-content-center',$image_hover_style ));
            //gride class
            $grid_classes = [];
            $grid_classes[] = 'col-xl-' . $settings['per_line'];
            $grid_classes[] = 'col-md-' . $settings['per_line_tablet'];
            $grid_classes[] = 'col-sm-' . $settings['per_line_mobile'];
            $grid_classes = implode(' ', $grid_classes);
            $this->add_render_attribute('team_gride_classes', 'class', [$grid_classes]);
        }


        // Query
        $numabr_of_membar = !empty($settings['membar_per_page']) ? $settings['membar_per_page'] : -1;
        $query_args = [
            'post_type'           => 'team',
            'orderby' => $settings['orderby'],
            'order'   => $settings['order'],
            'posts_per_page'      => $numabr_of_membar,
            'post_status'         => 'publish',
            'ignore_sticky_posts' => 1,
        ];

        // get_type
        if ( 'selected' === $settings['post_by'] ) {
            $query_args['post__in'] = (array)$settings['post__in'];
        }

        $team_teams = new \WP_Query($query_args);
        ?>
    <div class="team-area <?php echo esc_attr( $team_style ) ?>">

        <div <?php echo $this->get_render_attribute_string('team_version'); ?>>
        <?php while ($team_teams->have_posts()): $team_teams->the_post();  ?>

            <div <?php echo $this->get_render_attribute_string('team_gride_classes'); ?>>
                <div class="single-item hello">
                    <div class="team-wrapper">

                        <?php if(has_post_thumbnail() ): ?>
                            <a href="<?php the_permalink(); ?>"class="team-image">
                                <?php the_post_thumbnail('full');?>
                            </a>
                        <?php endif; ?>

                        <div class="user-identity">
                            <h6><?php the_title();?></h6>
                            <?php if (function_exists('the_field')): ?>
                                <span><?php the_field('position')?></span>
                            <?php endif;?>
                            <?php if (function_exists('the_field')  && 'yes' == $settings['show_socail_links'] ):
                                $social_links = get_field('social_links');
                                ?>
                                <div class="social-icons">
                                    <ul class="list-unstyled">
                                        <?php foreach( $social_links as  $social_link):  ?>
                                        <li>
                                            <a href="<?php echo esc_url($social_link['url']); ?>">
                                            <?php echo $social_link['icon'] ?>
                                            </a>
                                        </li>
                                        <?php endforeach; ?>
                                    </ul>
                                </div>
                            <?php endif;?>

                            <?php if ( 'yes' == $settings['show_readmore'] ): ?>
                                <div class="team-btn-wrap">
                                    <a class="team-btn"
                                        href="<?php the_permalink(); ?>">
                                        <?php if ( 'before' == $settings['icon_position'] && !empty( $settings['icon']['value'] ) ): ?>
                                        <span
                                            class="icon-before btn-icon"><?php \Elementor\Icons_Manager::render_icon( $settings['icon'], ['aria-hidden' => 'true'] )?></span>
                                        <?php endif;?>
                                        <?php echo esc_html( $settings['readmore_text'] ); ?>
                                        <?php if ( 'after' == $settings['icon_position'] && !empty( $settings['icon']['value'] ) ): ?>
                                        <span
                                            class="icon-after btn-icon"><?php \Elementor\Icons_Manager::render_icon( $settings['icon'], ['aria-hidden' => 'true'] )?></span>
                                        <?php endif;?>
                                    </a>
                                </div>
                            <?php endif;?>
                        </div>
                        
                    </div>
                </div>
            </div>
        <?php endwhile; wp_reset_postdata();?>
    </div>

    <?php if ( 'yes' == $settings['show_slider_settings'] && 'yes' == $settings['arrows']): ?>
        <div class="team-slider-arrow">

            <?php if ( ! empty( $settings['arrow_prev_icon']['value'] ) ) : ?>
                <button type="button" class="slick-prev prev slick-arrow slick-active">
                    <?php Icons_Manager::render_icon( $settings['arrow_prev_icon'], ['aria-hidden' => 'true'] ); ?>
                </button>
            <?php endif; ?>

            <?php if ( ! empty( $settings['arrow_next_icon']['value'] ) ) : ?>
                <button type="button" class=" slick-next next slick-arrow ">
                    <?php Icons_Manager::render_icon( $settings['arrow_next_icon'], ['aria-hidden' => 'true'] ); ?>
                </button>
            <?php endif; ?>
        </div>
    <?php endif; ?>




</div>
    <?php
}
}
$widgets_manager->register_widget_type(new \ZuzuTeam());