<?php

use Elementor\Icons_Manager;
?>

<div class="zuzu--tn-single <?php echo esc_attr($testimonial_style); ?>">



    <div class="zuzu-tn-bottom-style-four">

        <div class="zuzu--tn-user-identity">
            <div class="zuzu--tn-top">
                <?php if (has_post_thumbnail()) : ?>
                    <div class="zuzu--t-thumb">
                        <?php the_post_thumbnail('medium') ?>
                    </div>
                <?php endif; ?>
            </div>
            <div class="zuzu--tn-name-title">
                <h4 class="zuzu--tn-name">
                    <?php the_title() ?>
                </h4>

                <?php if (function_exists('the_field')) : ?>
                    <span class="zuzu--tn-title">
                        <?php echo get_field('designation') ?>
                    </span>
                <?php endif; ?>
            </div>
        </div>



        <div class="zuzu--tn--social-links">
            <?php if (function_exists('the_field')  && 'yes' == $settings['show_socail_links']) :
                $social_links = get_field('social_links');
            ?>
                <div class="social-icons">
                    <ul class="list-unstyled">
                        <?php foreach ($social_links as  $social_link) :  ?>
                            <li>
                                <a href="<?php echo esc_url($social_link['url']); ?>">
                                    <?php echo $social_link['icon'] ?>
                                </a>
                            </li>
                        <?php endforeach; ?>
                    </ul>
                </div>

            <?php endif; ?>
        </div>
    </div>


    <div class="zuzu--tn-dis">
        <?php echo zuzu_get_meta($content); ?>
    </div>

    <?php if (function_exists('the_field')) :
         $ratting = get_field('review_rating'); ?>
        <div class="zuzu--tn-rating">
            <?php for ($i = 0; $i < $ratting; $i++) : ?>
                <?php Icons_Manager::render_icon($settings['icon'], ['aria-hidden' => 'true']) ?>
            <?php endfor; ?>
        </div>
    <?php endif; ?>
</div>